<template>
    <Header/>
    <div class="d-lg-flex justify-content-evenly align-items-start primary main p-4">
        <div class="d-flex flex-column justify-content-around menu-portion p-4 bg-secondary text-white">
            <section v-for="(foods, type_name) in q">
                <h1 class="fs-1">{{ type_name }}</h1>
                <div v-for="food in foods" class="d-flex">
                    <PortionFrame :productName="o[food].category_name" :portionType="o[food].portion_size" v-model:quantity="user_quantity[Number(food)]" :id="Number(food)"/>
                </div>
            </section>
            <section>
                <p>Mangez-vous des fruits et légumes de saison ?</p>
                <CFormSelect v-model="season" aria-label="Default select example">
                    <option :value="3" >Je n'y fais pas attention ou je ne sais pas</option>
                    <option :value="2">J'essaie</option>
                    <option :value="1">Toujours</option>
                </CFormSelect>
                <p>Mangez-vous des fruits et légumes locaux ?</p>
                <CFormSelect v-model="local" aria-label="Default select example">
                    <option :value="0">Je n'y fais pas attention ou je ne sais pas</option>
                    <option :value="0.5">Je fais des efforts</option>
                    <option :value="1">Je consomme des fruits et légumes produits à moins de 150 km de chez moi</option>
                </CFormSelect>
            </section>
            <button type="button" class="btn btn-outline-light">Valider</button>
        </div>
        <div class="menu position-sticky top-0">
            <Menu v-model:active-tab="idTabActive" />
            <FootprintDashboard v-if="idTabActive === 1" :user_means="user_means"/>
            <WaterNLandDashboard v-if="idTabActive === 2" :IndicatorValue="land_use" :paliers="[0, 100, 140, 180, 220]" :vmax="300" color="#A1C180"/>
            <WaterNLandDashboard v-if="idTabActive === 3" :IndicatorValue="ef_score" :paliers="[0, 0.209, 0.265, 0.325, 0.385]" :vmax="0.4" color="#FF7F50"/>
        </div>
    </div>
</template>

<script>
import Header from "../components/Header.vue"
import outil from "../data/outil_WEB.json";
import user from "../data/user-default.json";
import { CFormSelect } from "@coreui/vue";
import Menu from "../components/Menu.vue";
import PortionFrame from "../components/PortionFrame.vue";
import FootprintDashboard from "../components/FootprintDashboard.vue";
import WaterNLandDashboard from "../components/WaterNLandDashboard.vue";
import questions from "../data/questions.json";

export default {
    name: "Steppes",
    components: {
        Header,
        Menu,
        PortionFrame,
        FootprintDashboard,
        WaterNLandDashboard,
        CFormSelect,
    },
    data() {
        return {
            o: outil,
            q: questions,
            user_quantity: user,
            idTabActive: 1,
            local: 0,
            season: 3,
        }
    },
    computed: {
        user_means() {
            console.log("user mean is computed")
            let means = {
                "Fruits et légumes": 0,
                "Produits laitiers": 0,
                "Produits céréaliers": 0,
                "Source de protéines": 0,
                "Petits-déjeuners et goûters":0,
                "Sucreries": 0,
                "Boissons": 0
            }
            var C = 0    
            console.log(this.season)
            for (let id in this.user_quantity) {
                switch (this.season) {
                    case 1:
                        C = this.local*outil[id]["carbon_local_season"] + (1 - this.local) * outil[id]["carbon_season"]
                        break;
                    case 3:
                        C = this.local*outil[id]["carbon_local"] + (1 - this.local)*outil[id]["carbon_default"]
                        break;
                    default:
                        C = this.local/2*(outil[id]["carbon_local"] + outil[id]["carbon_local_season"]) + (1 - this.local)/2 * (outil[id]["carbon_season"]+outil[id]["carbon_default"])
                        break;
                }
                
                means[outil[id]["type_name"]] += Number(this.user_quantity[id.toString()])*C*outil[id]["portion_size"]/1000*52
            }
            return means
        },
        land_use() {
            let g = 0;
            let f = 0;
            for (let id in this.user_quantity) {
                g += Number(this.user_quantity[id.toString()])*outil[id]["land_use"]*outil[id]["portion_size"]
                f += Number(this.user_quantity[id.toString()])*outil[id]["portion_size"]
            }
            if (f==0) {return 0}
            return g/f;
        },
        ef_score() {
            let g = 0;
            let f = 0;
            for (let id in this.user_quantity) {
                g += Number(this.user_quantity[id.toString()])*outil[id]["EF_score"]*outil[id]["portion_size"]
                f += Number(this.user_quantity[id.toString()])*outil[id]["portion_size"]
            }
            if (f==0) {return 0}
            return g/f;
        },
    }
}
</script>

<style>
</style>